/*************************************************
* Device EntropySource Header File               *
* (C) 1999-2007 Jack Lloyd                       *
*************************************************/

#ifndef BOTAN_ENTROPY_SRC_DEVICE_H__
#define BOTAN_ENTROPY_SRC_DEVICE_H__

#include <botan/entropy_src.h>
#include <vector>
#include <string>

namespace Botan {

/*************************************************
* Device Based Entropy Source                    *
*************************************************/
class BOTAN_DLL Device_EntropySource : public EntropySource
   {
   public:
      std::string name() const { return "RNG Device Reader"; }

      Device_EntropySource(const std::vector<std::string>& fs) :
         fsnames(fs) {}

      u32bit slow_poll(byte[], u32bit);
      u32bit fast_poll(byte[], u32bit);
   private:
      std::vector<std::string> fsnames;
   };

}

#endif
